<%
'*********************************************************************
' Advanced Form Handling 4.00
' March 10, 2008    add gettcurrentdate and getcurrent time
' Set of common display routines 
' Copyright: HK Programming
' This is simply a set of small subroutines that do
' common taks related to form creation and display
'
'   DebugWrite (msg)
'   WriteErrorMessage (msg)
'   DisplayPageHeader
'   DisplayPageTrailer
'   DisplayAdminPageHeader
'   DisplayAdminPageTrailer
'   Requesttext(fieldname)
'   DisplayErrors (msg) 
'   DisplayHeader (msg)
'   GenerateFormAction (action, formname)
'   GenerateFormEnd (formname)
'   WriteFormRowText (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage)
'   WriteFormRowPassword (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage)
'   WriteFormRowTextarea (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage, rows)
'   WriteFormRowNull (fieldcaption, fieldvalue)
'   Responsewrite (msg)
'   WriteFormRowListMultiple (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, currentvalues, currentcount)
'   CreateSelectionListMultiple (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, currentvalues, currentcount)
'   WriteFormRowList (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldhelpmessage)
'   WriteFormRowListVariable (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldhelpmessage, Listvalues)
'   WriteFormRowListRecordset (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, prompt, fieldhelpmessage, conn, sql, valuefield, displayfield)
'   WriteFormRowListSelection (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldselect)
'   CreateSelectionList (fieldname, fieldvalue, listarray, listcount, prompt)
'   WriteArrayList (listarray, listcount)
'   IsValidReferer (list)
'   htmlSubheading (caption)
'   isAlphaNumeric(strValue, strOtherCharacters) 
'   arraysort(values())
'   AddErrorMsg (msg) 
'   ValidateTable
'   Function WriteSectionHeader (fieldcaption)
'   GenerateformRequestPrompt (infomsg, actionurl)
'*********************************************************************
const htmlTable="<center><table border=0 cellpadding=0 cellspacing=0>"
Const htmlTableEnd="</table></center>"
Const htmlRowStart="<tr valign='top'>"
const htmlrowend="</tr>"
const htmlcolumnstart="<td>"
const htmlcolumnend="</td>"
const htmlcolumnstartcaptiongood="<td valign='middle'><b><font face='arial'>"
const htmlcolumnstartcaptionbad="<td valign='middle'><b><font face='arial' color='#ff0000'>"
const htmlcolumnendcaption="</b></font></td>"
const htmlTableLogin="<table cellpadding=2 cellspacing=1 border=0>"
Const htmlinfoFont="<font size=2 face=verdana color='#0000CC'><b>"
Const htmlinfofontend="</b></font>"
const htmlerrorfont="<font face='verdana,arial' Color='#0000FF'><b>"
const htmlerrorfontend="</b></font>"
const htmlleftfont="<b>"
const htmlleftfontend="</b>"
const htmlmenutable="<table border='0' cellpadding='1' cellspacing='1' width='50%'>"
const htmlmenuheaderrow="<tr>"
const htmlmenuheadercolumn="<td colspan=2 width='45%' align='center'><b>"
const htmlmenuheadercolumnend="</b></td>"
const htmlmenurow="<tr>"
const htmlmenucolumn="<td class='adminmainlink' align=left><p><b>"
const htmlmenucolumnend="</b></td>"
' Reports reports
const htmlReportTable="<table border=0 align=center cellpadding=2 cellspacing=1>"
const htmlReportHeaderRow="<tr>"
Const htmlReportHeaderRowEnd="</tr>"
const htmlReportHeaderColumn="<td align=center><b>"
const htmlReportHeaderColumnEnd="</b></td>"
const htmlReportDetailRow="<tr bgcolor='#FFFFFF'>"
const htmlReportDetailRowX="<tr bgcolor='#CCCCCC'>"
const htmlReportDetailColumn="<td valign='top' align=left>"
const htmlreportDetailColumnEnd="</td>"
Const htmlReportDetailRowEnd="</tr>"
const htmlReportTableEnd="</table>"
' Navigation
const htmlPageNavTable="<table border=0 width='50%'>"
const htmlPageNavRow="<tr align=center>"
const htmlPageNavColumn="<td align=center>"
const htmlPageNavFont="<font face='tahoma,arial,verdana'>"
const htmlPageNavFontEnd="</font>"
const htmlPageNavTableEnd="</td></tr></table>"

const htmlsubTable="<table border=0 cellpadding=0 cellspacing=0>"
const htmlsubrow="<tr>"
const htmlsubrowend="</tr>"
const htmlsubcolumn="<td>"
const htmlsubcolumnend="</td>"
const htmlsubtableend="</table>"
const htmlleftcolumn="<td width='160' valign='top' class='NormalBold'>"
const htmlrightcolumn="<td valign='top' class='Normal'>"

Sub DebugWrite (msg)
responsewrite msg & "<br>"
end sub
'*****************************************************************************
' Writes an error message in a new form
'*****************************************************************************
Sub WriteErrorMessage (msg)
writesess "errormessage",msg
responseredirect "afherror.asp"
end sub

'******************************************************************
' General Usage Display Headers and trailers on ASP pages
' afhheadertrailer.asp
'***************************************************************
Sub DisplayPageHeader
Afhheader
end sub
Sub DisplayPageTrailer
afhtrailer
end sub

Sub DisplayAdminPageTrailer
AfhadminTrailer
end sub
'
Sub DisplayAdminPageHeader
AfhadminHeader
end sub
'**********************************************************************************************
' get value from querystring or form and Filter it to avoid hacker problems
'*********************************************************************************************
Function Requesttext(fieldname)
dim fieldvalue
fieldvalue=request(fieldname)
fieldvalue=filtertext(fieldvalue)
requesttext=fieldvalue
end function
'**********************************************************************************************
' get value from querystring or form and Filter it to avoid hacker problems
'*********************************************************************************************
Function Requestquerystring(fieldname)
dim fieldvalue
fieldvalue=request.querystring(fieldname)
fieldvalue=filtertext(fieldvalue)
requestquerystring=fieldvalue
end function

'**********************************************************************************************
' get value from querystring or form and Filter it to avoid hacker problems
'*********************************************************************************************
Function Requestform(fieldname)
dim fieldvalue
fieldvalue=request.form(fieldname)
fieldvalue=filtertext(fieldvalue)
requestform=fieldvalue
end function
'***********************************************************************
Sub DisplayErrors (msg)
response.write "<br>" & htmlerrorfont & msg & htmlerrorfontend & "<br>"
end sub

'***********************************************************************
Sub DisplayHeader (msg)
responsewrite htmlinfofont & msg & htmlinfofontend & "<br>"
end sub
'****************************************************************************
' Generate  a form action HTML statement
function GenerateFormAction (action, formname)
responsewrite ("<form action='" & action & "' method='post' name='" & formname & "'>")
end function

function GenerateFormEnd (formname)
responsewrite ("</form>")
end function


'*****************************************************************************
' generate table
'******************************************************************************
Function GenerateTable 
Responsewrite ("<table border=0 cellpadding=0 cellspacing=0>")
end function
'*****************************************************************************
' generate table
'******************************************************************************
Function GenerateTableEnd 
Responsewrite ("</table>")
end function

'***************************************************************************
' Create a text row
'***************************************************************************
Function WriteFormRowText (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
responsewrite "<input type='text' class=input-text name='" & fieldname & "' size='" & fieldsize & "'" & " value='" & fieldvalue & "'>"
responsewrite "</td></tr>"

end function

Function WriteFormRowPassword (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
responsewrite "<input type='password' class=input-text name='" & fieldname & "' size='" & fieldsize & "'" & " value='" & fieldvalue & "'>"
responsewrite "</td></tr>"
end function

Function WriteFormRowTextarea (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, fieldhelpmessage, rows)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
Responsewrite ("<textarea name='" & fieldname & "'" & " rows=" & rows & " cols='" & fieldsize & "'>" & fieldvalue & "</textarea>")
responsewrite "</td></tr>"
end function

Function WriteFormRowNull (fieldcaption, fieldvalue)
%>
<tr> 
<td valign="middle" class="NormalBold"><%=fieldcaption%>	</td>
<td valign="middle" class="Normal"><%=fieldvalue%></td>
</tr>
<%
end function


'*********************************************************************************
' Writes a message to browser
'*******************************************************************************
Function Responsewrite (msg)
response.write msg
response.write vbcrlf
end function

'***************************************************************************************
' Generates a row using an array 
'****************************************************************************************
Function WriteFormRowListMultiple (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, currentvalues, currentcount)
responsewrite (htmlrowstart & htmlcolumnstart )
responsewrite (Htmlleftfont)
responsewrite (fieldcaption)
responsewrite (htmlleftfontend & htmlcolumnend)
responsewrite (htmlcolumnstart)
CreateSelectionListMultiple fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, currentvalues, currentcount
Responsewrite (htmlcolumnend & htmlrowend)
end Function

Sub CreateSelectionListMultiple (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, currentvalues, currentcount)
Currentvalue=""
dim i, j,Currentvalue,found
responsewrite ("<select MULTIPLE size=" & fieldsize & " class='txtfielddropdown' name='" & fieldname & "'>")
If prompt<>"" then
   responsewrite ("<option>" & prompt & "</option>")
end if
for i = 0 to listcount-1
   If currentcount> 0 then
        Found=FALSE
        j=0
        Do WHILE found=FALSE and j < currentcount
            if listarray(i)= Currentvalues(j) then
                currentvalue=listarray(i)
                found=TRUE
                exit do
            end if
            j=j+1 
        Loop
   end if
   If currentvalue= listarray(i) then
      responsewrite ("<option Selected>" & listarray(i) & "</option>")
   else
      responsewrite ("<option>" & listarray(i) & "</option>")
   end if
next
responsewrite ("</select>")
end sub

'***************************************************************************************
' Generates a row using an array 
'****************************************************************************************
Function WriteFormRowList (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldhelpmessage)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
CreateSelectionList fieldname, fieldvalue, listarray, listcount, prompt
responsewrite "</td></tr>"
end function


'***************************************************************************************
' Generates a row using an array  with variables
'****************************************************************************************
Function WriteFormRowListVariable (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldhelpmessage, Listvalues)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
CreateSelectionListVariable fieldname, fieldvalue, listarray, listcount, prompt,listvalues
responsewrite "</td></tr>"
end function



' Generates a row using an array 
'****************************************************************************************
Function WriteFormRowListRecordset (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, prompt, fieldhelpmessage, conn, sql, valuefield, displayfield)
responsewrite ("<tr>")		
responsewrite "<td valign='middle' class='NormalBold'>" & fieldcaption  & "&nbsp;"
If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
end if
responsewrite "</td>"
responsewrite "<td valign='top' class='Normal'>"
if fieldhelpmessage<>"" then 
  responsewrite "<span class='NormalHelpStyle'>" & fieldhelpmessage & "</span><br>"
end if
GenerateTablefromRs Conn,sql,fieldname,valuefield,displayfield,fieldvalue, prompt
responsewrite "</td></tr>"
end function


'***************************************************************************************
' Generates a row using an array of three columns
' caption, list, textbox
'****************************************************************************************
Function WriteFormRowListSelection (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldselect)
dim i
responsewrite (htmlrowstart & htmlcolumnstart )
responsewrite (Htmlleftfont)
responsewrite (fieldcaption)
responsewrite (htmlleftfontend & htmlcolumnend)
responsewrite (htmlcolumnstart) 
CreateSelectionList fieldname, fieldvalue, listarray, listcount, prompt
Responsewrite (htmlcolumnend)
responsewrite (htmlcolumnstart)
Responsewrite ("<input type='text' name='" & fieldselect & "'" & " size='" & fieldsize & "'" & " value='" & fieldvalue & "'>")
responsewrite (htmlcolumnend)
responsewrite (htmlrowend)
end function

'******************************************************************************
' selection list based on an input array
'*****************************************************************************
Sub CreateSelectionList (fieldname, fieldvalue, listarray, listcount, prompt)
dim i
responsewrite ("<select size=1 class='txtfielddropdown' name='" & fieldname & "'>")
If prompt<>"" then
   responsewrite ("<option>" & prompt & "</option>")
end if
for i = 0 to listcount-1
  ' Debugwrite "fieldvalue=" & fieldvalue &  " array=" & listarray(i)
   If fieldvalue= listarray(i) then
      responsewrite ("<option selected>" & listarray(i) & "</option>")
   else
      responsewrite ("<option>" & listarray(i) & "</option>")
   end if
next
responsewrite ("</select>")
end sub


'******************************************************************************
' selection list based on an input array ising variables
'*****************************************************************************
Sub CreateSelectionListVariable (fieldname, fieldvalue, listarray, listcount, prompt, listvalues)
dim i, formvalue
responsewrite ("<select size=1 class='txtfielddropdown' name='" & fieldname & "'>")
If prompt<>"" then
   responsewrite ("<option>" & prompt & "</option>")
end if
for i = 0 to listcount-1
   formvalue=listvalues(i) 
   If fieldvalue=formvalue then
      response.write "<option value='" & formvalue  & "' " & " selected>" &  listarray(i) & "</option>" & vbcrlf
   else
      response.write "<option value='" & formvalue & "'>" &  listarray(i) & "</option>" & vbcrlf
   end if   
next
responsewrite ("</select>")
end sub


'*****************************************************************************
' adds  message  to errormsg global variable
'****************************************************************************
Sub AddErrorMsg (msg)
'debugwrite "adding error msg=" & msg
errormsg=errormsg & msg & "<br>"
end sub
'******************************************************************************
' Add The following fields are required
'*****************************************************************************
Sub AddErrorRequired
Errormsg=readlang("Langrequiredfields") & "<br>" & errormsg 
end sub

'******************************************************************************
' Create a submit button with name of submit
' unoess otherwise specified
'*****************************************************************************
Sub GenerateSubmitButton (buttonname, buttontext, buttonimage)
dim tempname
tempname=buttonname
if tempname="" then
  tempname="Submit"
end if  
'responsewrite "<center>"
If buttonimage="" then
   ResponseWrite("<input type=submit name=" & tempname & " value=""" & buttontext & """>") 
else
    ResponseWrite("<input type=image border='0' name=" & tempname & " src=""" & buttonimage & """>")
end if
'Responsewrite "</center>"    
end sub


Sub GenerateResetButton (buttonname, buttontext,buttonimage)
dim tempname, resetname
tempname=buttonname
if tempname="" then
  tempname="Reset"
end if  
resetname="document." & tempname & ".reset()"
If buttonimage="" then
   Response.Write("<input type=reset name=" &tempname & " value=""" & buttontext & """>")
else
   Response.Write("<img border='0' src='" & buttonimage & "' onclick='" & resetname & "'>")  
end if    
end sub


'*************************************************************************
' create a standard hyperlink
'**************************************************************************
Function Generateurl(filename, caption)
dim url
url="<a href='" & filename & "'>" & caption & "</a>"
Generateurl=Url
end function

'*************************************************************************
' create a standard hyperlink
'**************************************************************************
Function Generateurlpop(filename, caption)
dim url
url="<a href='#' onclick=""window.open('" & filename & "','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"">" & caption & "</a>"
'url="<a href='" & filename & "' target='_blank'>" & caption & "</a>"
Generateurlpop=Url
end function

'******************************************************************************
' get form field value. If "select" then it is null
' If null then set a default value
'*****************************************************************************
Sub readformvalue (formname, formvalue, defaultvalue)
dim ignorevalue, findname, index, rc
ignorevalue=lcase(readlang("Langselect"))
findname=lcase(formname)
locateformfield findname, formvalue, formfieldvalues, formfieldnames, formfieldcount, index, rc
If rc=0 then
   if lcase(formvalue)=ignorevalue then
      formvalue=""
   end if
end if
if formvalue="" then
   formvalue=defaultvalue
end if 
formindex=index                     ' formindex is global        
end sub
'*********************************************************************************
' search form fields array to find form field name
'**********************************************************************************
sub  locateformfield (formname, formvalue, formvalues, formfields, formfieldcount, formindex, rc)
dim i
for i = 0 to formfieldcount-1
    if formname=formfields(i) then
       formindex=i
       formvalue=formvalues(i)
       rc=0
       exit sub
    end if
next
rc=4
formindex=-1        
end sub

sub readformvaluebutton (buttonname,buttonvalue,defaultvalue)
dim tempname
tempname=buttonname
buttonvalue=request(tempname)
if buttonvalue="" then
   tempname=tempname & ".x"               ' for images
   buttonvalue=request(tempname) 
end if
if buttonvalue="" then
   buttonvalue=defaultvalue
end if   
end sub

'*********************************************************************************
' write hidden Fields in a form
'*********************************************************************************
Sub WriteHiddenField (fieldname, fieldvalue)
responsewrite ("<input type=hidden name='" & fieldname & "' value=" & Chr(34) & fieldvalue & Chr(34) & ">")
end sub

' Validation Functions
'********************************************************************
' basic email check
'*******************************************************************
function isValidEmail(byval sEmail)
dim returnVal
' very simple email validation function.
	returnVal = false
	if not isEmpty(sEmail) then
		if instr(sEmail, "@") > 0 and instr(sEmail, ".") > 0 then
			returnVal = true
		end if
	end if
	isValidEmail = returnVal
end function
'*************************************************************************
' Test for valid data
'**********************************************************************
Function isValidTextField (byval sfieldvalue)
dim returnval
if sfieldvalue="" then 
   returnval=false
else
  returnval=True
end if   
isvalidTextField = returnVal
end function


'***************************************************************************
'Take  adte field and add a# for access or quote(') for other databases
'***************************************************************************
Function DateDelimit (indate)
dim datedelim, newdate
datedelim="'"
if lcase(config_databasetype)="access"  or lcase(config_databasedriver)="access" then
  datedelim="#"
end if  
newdate=DateNormalize(indate)
dateDelimit  = datedelim & newdate & datedelim
end function
'
'****************************************************************************
' take a date and chnage to yyyy-mm-dd
'**************************************************************************
Function DateNormalize(indate)
Dim yyyy,mm,dd,newdate
yyyy=datepart("yyyy",indate)
mm= datepart("m",indate)
If len(mm)=1 then
   mm="0" & mm
end if   
dd=datepart("d",indate)
if len(dd)=1 then
  dd="0" & dd
end if  
newdate=yyyy & "-" & mm & "-" & dd
DateNormalize=newdate
end Function

'*****************************************************************************
' take a string in form
'  a,b,c and turn into an array
'*****************************************************************************
Sub ConvertToArray (record,words,wordcount,delimiter)
Dim pos 
Dim recordl
Dim bytex
Dim temprec
Dim maxwords
Dim i
maxwords = 10
temprec = record
Dim maxentries
pos = 1
wordcount = 0
' make sure word array is null
maxentries = UBound(words)
For i = 0 To maxentries - 1
   words(i) = ""
Next
recordl = Len(temprec)
' first eliminate leading blanks
Do
   bytex = Mid(temprec, pos, 1)
   While bytex = " " And pos <= recordl
     pos = pos + 1
     bytex = Mid(temprec, pos, 1)
   
   Wend
' copy word into word array
   While bytex <> delimiter And pos <= recordl
     words(wordcount) = words(wordcount) & bytex
     pos = pos + 1
     bytex = Mid(temprec, pos, 1)
     
   Wend
   wordcount = wordcount + 1
   pos = pos + 1
   If wordcount > maxentries Then Exit Sub
Loop Until pos > recordl
End Sub

'*************************************************************************
'  Generate a select based on table with sql supplied
'  first field normally "select" but if null, no select is added
'******************************************************************************
Sub GenerateTablefromRs (Conn,sql,selectname,valuefield,displayfield,currentvalue, firstfield)
dim grs,  fieldvalue, eofflag, fieldname, selected
openrecordset conn, grs, sql, eofflag
if grs.eof then 
   closerecordset grs
   exit sub
end if 
selected=""
' Generates Select with values
responsewrite "<select size=1 class='txtfielddropdown' name='" & selectname & "'>"
If firstfield<>"" then
    if currentvalue="" then  
      selected=" selected"
    end if  
     responsewrite ("<option value='" & firstfield & "'" & " selected>" & firstfield & "</option>")

end if     
do while not grs.eof   
      fieldvalue=getrsfield(grs,valuefield)
      fieldname=getrsfield(grs, displayfield)
      If currentvalue= fieldvalue then
        responsewrite ("<option value=" & fieldvalue & " selected>" &  Fieldname & "</option>")
       else
        responsewrite ("<option value='" & fieldvalue & "'>" &  fieldname & "</option>")
      end if
      rsmovenext  grs
loop
responsewrite "</select>"
closerecordset grs
end sub
'********************************************************************************
' Gets all fields in form and stores them into an array
'******************************************************************************
Sub GetFormInputValues( formfieldnames, formfieldvalues, formfieldsvalid, formfieldcount)
dim field, fieldvalue 
formfieldcount=0
for each field in request.form 
    fieldvalue=request.form(field) 
    formfieldnames(formfieldcount)=lcase(field)
    formfieldvalues(formfieldcount)=fieldvalue
    formfieldsvalid(formfieldcount)=True
    If fieldvalue<>"" then
       formfieldlengths(formfieldcount)=len(fieldvalue)
    end if   
    formfieldcount=formfieldcount+1
    
next    
end sub
'******************************************************************************
' The information about the form we are processing
' has already been read into memory and placed in arrays
' we want to find one of these values
'*****************************************************************************
Sub FindFormRecordField (fieldname, fieldvalue, defaultvalue,rc )
dim formdbindex
fieldvalue=defaultvalue
locateformfield fieldname, fieldvalue, formdbvalues, formdbnames, formdbcount, formdbindex, rc
If fieldvalue="" then
   fieldvalue=defaultvalue
end if   
'debugwrite "field searched=" & fieldname & " found=" & fieldvalue
end sub

'************************************************************************
' see if file exists and if so display it
'************************************************************************
Sub WriteDisplayFile  (filename, rc)
redim filearray(xdefaultfilesize)
dim filearraycount, i
if filename="" then 
   responsewrite "Filename is missing for writedisplayfile"
   rc=4
   exit sub
end if   
ReadSystemFile filename, rc, filearray, filearraycount
if rc>0 then exit sub
for i = 0 to filearraycount-1
   responsewrite (filearray(i))
next
end sub

Function GenerateCheckbox (formname, formvalue, selected)
dim tempvalue
tempvalue="<input type=checkbox " & " name='" & formname & "'" & " value='" & formvalue & "'" & selected & ">"
generatecheckbox=tempvalue
end function


'***************************************************************************************
' Generates a radio set of values
'****************************************************************************************
Function WriteFormRowRadio (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, captions, fieldhelpmessage)
%>
<tr>		
	<td width="160" valign="top" class="NormalBold"><%=fieldcaption%>
	<% If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
	   end if
	%>   
	</td>
	<td valign="top" class="Normal">
	<% if fieldhelpmessage<>"" then 
	%>
	 	<span class="InlineHelpStyle"><%=fieldhelpmessage%></span><br>
	<%
	end if
	CreateRadioList fieldname, fieldvalue, listarray, listcount, captions
	%>   			
	</td>
	</tr>
<%
end function

Function GenerateRadio (formname, formvalue, selected)
dim tempvalue
tempvalue="<input type=radio " & " name='" & formname & "'" & " value='" & formvalue & "'" & selected & ">"
generateradio=tempvalue
end function

function CreateRadioList (fieldname, fieldvalue, listarray, listcount, captions)
dim i, selected
dim radiovalue, radiotext, caption
%>
 <table border="0" cellpadding="3" cellspacing="0">
<% 
for i =0 to listcount-1
    radiovalue=listarray(i)
    caption=captions(i)
   if fieldvalue<>"" and radiovalue=fieldvalue then 
      selected=" checked"
   else
     selected=""
   end if      
%>   
   <tr>
   <td>	
   <%
   responsewrite "<input type=radio " & " name='" & fieldname & "'" & " value='" & radiovalue & "'" & selected & ">"
   %>
  <span class="Normal"><%=caption%></span>
  </td>
  </tr>
<%
next
responsewrite ("</table>")    
end function

'***************************************************************************************
' Generates a radio set of values
'****************************************************************************************
Function WriteFormRowCheckbox (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, captions, selectvalues, selectvaluescount)
%>
<tr>		
	<td width="160" valign="top" class="NormalBold"><%=fieldcaption%>
	<% If fieldrequired=True then 
		responsewrite ("<span class='Required'>*</span>")
	   end if
	%>   
	</td>
	<td valign="top" class="Normal">
	<% if fieldhelpmessage<>"" then 
	%>
	 	<span class="InlineHelpStyle"><%=fieldhelpmessage%></span><br>
	<%
	end if
	CreateCheckboxList fieldname, fieldvalue, listarray, listcount, captions, selectvalues, selectvaluescount
	%>   			
	</td>
	</tr>
<%
end function

'****************************************************************************
' create a checkbox for every value in list array
'***************************************************************************
Sub CreateCheckboxList (fieldname, fieldvalue, listarray, listcount, captions, selectvalues, selectedcount)
dim i, selected, j
responsewrite htmlsubtable
dim checkvalue, checktext
for i =0 to listcount-1
   responsewrite (htmlsubrow & htmlsubcolumn)
   responsewrite captions(i)
   responsewrite (htmlsubcolumnend)
   responsewrite (htmlsubcolumn)
   checkvalue=listarray(i)
   selected=""
   If selectedcount<>0 then
      for j=0 to selectedcount-1
        if selectvalues(j)=checkvalue then
          selected=" checked"
          exit for
        end if
      next    
   end if
   checktext=generatecheckbox(fieldname, checkvalue, selected) 
   responsewrite checktext
   responsewrite (htmlsubcolumn & htmlsubrowend) 
next    
responsewrite (htmlsubtableend)
end sub



'****************************************************************************
Sub Getformattributes(formname)
dim rs, sql, idfield, recordno, eofflag
recordno=1
sql="select * from forms where formname='" & formname & "'"
openrecordset conn, rs, sql, eofflag
if not rs.eof then
  ReadRsvalues rs, formdbnames, formdbtypes, formdblengths, formdbvalues, formdbcount, idfield,recordno        
else
   errormsg=readlang("langformnotfound") & "=" &    formname
end if 
closerecordset rs  
end sub
'********************************************************************
' create form from ecordset
'********************************************************************
Sub GenerateformRequestPrompt (infomsg, actionurl)
dim sql, selectname, valuefield, displayfield, currentvalue, firstfield
firstfield=""
currentvalue=""
selectname="form"
valuefield="formname"
displayfield="formname"
buttontext=readlang("langselect")
buttonimage=""
buttonname="submit"
sql="select * from forms order by formname"
displayheader infomsg & "<br>"
GenerateFormAction actionurl, "formselect"
GenerateTable
responsewrite htmlrowstart & htmlcolumnstart
GenerateTablefromRs  Conn,sql,selectname,valuefield,displayfield,currentvalue, firstfield
responsewrite htmlcolumnend & htmlrowend
generatetableend
GenerateSubmitButton buttonname, buttontext, buttonimage
Generateformend "formselect"
end sub

Function WriteSectionHeader (fieldcaption)
%>
<tr>
<td colspan="2" class="BlueBackgroundColor" align="center">
  <table cellpadding="3" border="0">
	<tr>
	<td align="center"><span class="Normalbold"><%=fieldcaption%></span>
	</td>
	</tr>
  </table>
</td>
</tr>
<%
end function
Sub ValidateTable
'********************************************
'See if user has access to this table
Dim UserTables, i
dim tablecount
if readconfig("XRestrictAdminTables")<>"Yes" then exit sub
UserTables=GetSess("UserTables")
If Isnull(UserTables) then
   exit sub
end if
if UserTables="" then
    exit Sub
else
     UserTables=split(GetSess("UserTables"),",",-1,1)
end if
tablecount=ubound(UserTables)
for i = 0 to tablecount
   if ucase(dbtable)=ucase(Usertables(i)) then
        exit sub
   end if
next
'Debugwrite "table being changed from " & dbtable
dbtable=""
end sub 

Function htmlFormheader1 (caption)
%>
<tr>
<td width="6" rowspan="33">
</td>
<td colspan="2" valign="top" class="Normal">
Please enter values in the form below. Note that all fields marked with an asterisk (<span class="Required">*</span>) are required.
</td>
<td width="6" rowspan="33">
</td>
</tr>
<%
end function
' sort an array
    function arraysort(values())
    Dim i 
    Dim j 
    Dim smallest_value 
    Dim smallest_j 
    dim min
    dim max
    dim temp
    
    min = lbound(values,2)
    max = ubound(values,2)
    	For i = min To max - 1
    	smallest_value = values(0,i)
    	smallest_j = i
    	For j = i + 1 To max
    		' See if values(j) is smaller. changed to strComp to work with strings.
    		If strComp(values(0,j),smallest_value,vbTextCompare) = -1 Then
    			' Save the new smallest value.
    			smallest_value = values(0,j)
    			smallest_j = j
    		End If
    		Next 'j
    		If smallest_j <> i Then
    			' Swap items i and smallest_j.
    			for intA = 0 to ubound(values,1)
    				temp = values(intA,smallest_j)
    				values(intA,smallest_j) = values(intA,i)
    				values(intA,i) = temp
    			next 'intA
    		End If
    	Next 'i
    arraysort = values
    End function

Function IsValidReferer (list)
dim rc, myarray(100), mycount, referer
rc=true
if list="" then
   Isvalidrefer=rc
   exit function
end if
rc=false
converttoarray list, myarray, mycount,","   
referer = GetHost(Request.ServerVariables("HTTP_REFERER"))
for i = 0 to mycount-1
  if lcase(myarray(i)) = lcase(referer) then
       rc=true 
       exit for
  end if
next
isValidReferer=rc  
end function
Function htmlSubheading (caption)
%>
<tr>
<td colspan="4" valign="middle">
 <table border="0" cellpadding="8" cellspacing="0" width="100%">
 <tr>
  <td><span class="H2HeadingStyle">&nbsp;<%=caption%></span></td>
 </tr>
 </table>
</td>
</tr>
<%
end function
Function htmlrequiredList(caption, fieldname, strvalue, listarray, listcount)
dim selected
selected=""
%>
<tr>
<td valign="top" class="NormalBold"><%=caption%><span class="Required">*</span></td>
<td valign="top" class="Normal">
<select name="<%=fieldname%>" style="width:290">
<%
for i = 0 to listcount-1
   if strvalue=listarray(i) then
      selected=" selected"
   end if
   responsewrite "<option" & selected   & " value='" & listarray(i) & "'>" & listarray(i) & "</option>"
next   
%>
</select>
</td>
</tr>
<%
end function


'***************************************************************************************
' Generates a table based on an array
'****************************************************************************************
sub WriteArrayList (listarray, listcount)
dim i
if listcount="" or listcount=0 then exit sub
generatetable
for i = 0 to listcount-1
 responsewrite (htmlrowstart & htmlrightcolumn)
 responsewrite "<b>" & listarray(i) & "</b>"
 responsewrite (htmlcolumnend & htmlrowend)
next 
generatetableEnd
end sub
'*************************************************************************
' formats dates based on patterns
'*************************************************************************
Function Formatdatefunc (iDate, itype)
  Dim strDate
  Dim intTrim
  intTrim = 1
  if len(itype) = 0 Then
    formatdatefunc = ""
  Else
  'Enter recursive function to format date
  Select Case Left(itype,1)
  Case "d"
    if Mid(itype, 2, 1) = "d" Then
      strDate = weekdayname(weekday(iDate)) & " " & datepart("d",iDate)
      intTrim = 2
    Else
      strDate = day(iDate)
    End If
  Case "m"
    if Mid(itype, 2, 1) = "m" Then
      strDate = monthname(month(iDate))
      intTrim = 2
    Else
      strDate = month(iDate)
    End If
  Case "y"
    if Mid(itype, 2, 3) = "yyy" Then
      strDate = year(iDate)
      intTrim = 4
    ElseIf Mid(itype, 2, 1) = "y" Then
      strDate = Right(year(iDate), 2)
      intTrim = 2
    Else
   strDate = Right(year(iDate), 2)
    End If
  Case " "
    strDate = " "
  Case "/"
    strDate = "/"
  Case "-"
    strDate = "-"
  Case "."
    strDate = "."
  Case Else
    Response.Write "<BR>Unknown date format"
  End Select
 formatdatefunc = strDate & formatdatefunc(iDate, Right(itype, Len(itype) -intTrim))
End If
End Function
'**********************************************************************
' not in free version
'**********************************************************************
Sub NotinFree (msg)
response.write "<br><b>" & msg & "<br><br>"
response.write "is not included in the free version"
response.write "</b><br>"
end sub

'*********************************************************************
' looks up caption in language file
' formation is
' formname_xxxxxx   where xxx is the fieldname
'**********************************************************************
function Readcaption (fieldname, dbtable)
dim tempname, tempvalue
tempname=dbtable & "_"  & fieldname
tempvalue=readlang(tempname)
if tempvalue=tempname then           ' not found
   tempvalue=fieldname               ' use fieldname as caption
end if
readcaption=tempvalue   
end function
'******************************************************************************
' Create a submit button with name of submit
' unoess otherwise specified
'*****************************************************************************
Sub GenerateFormButtononly (action, formname, buttonname, buttontext, buttonimage)
dim tempname
tempname=buttonname
if tempname="" then
  tempname="Submit"
end if  
GenerateFormAction action, formname
'responsewrite "<center>"
If buttonimage="" then
   Response.Write("<input type=submit name=" & tempname & " value=""" & buttontext & """>")
else
    Response.Write("<input type=image border='0' name=" & tempname & " src=""" & buttonimage & """>")
end if
'Responsewrite "</center>"  
GenerateFormEnd formname  
end sub

'**********************************************************************************************
' cleanup up any hacker attempts
' return a null string if any problems
'********************************************************************************************
Function FilterText (msg)
dim badChars,i,lmsg, pos
dim newChars 
dim newmsg
newmsg=""
If msg="" then
   Filtertext=msg
   exit function
end if   
badChars = array(";", "--", "@@","=","<script>") 
newChars = lcase(msg)
for i = 0 to uBound(badChars) 
   if instr(1,newchars,badchars(i),1)>0 then
       FilterText=newmsg
       exit function
   end if    
next
FilterText=msg
end function

Function Generateimageurl (filename, textvalue, imagefile)
dim url
url="<a href='" & filename & "'><img border='0' src='" & imagefile & "' alt='" & textvalue & "'></a>"
generateimageurl=url
end function


Function Generateimageurlpop (filename, textvalue, imagefile)
dim url
url="<a href='#' onclick=""window.open('" & filename & "','','width=550,height=400,menubar=no,toolbar=no,location=no,status=no,directories=no,copyhistory=no,resizable=yes,scrollbars=yes')"">" & "<img border='0' src='" & imagefile & "' alt='" & textvalue & "'></a>"
'url="<a href='" & filename & "' target='_blank'><img border='0' src='" & imagefile & "' alt='" & textvalue & "'></a>"
generateimageurlpop=url
end function


Sub Updatecaptionswithicons (captions, icons, listcount)
dim i, image, caption
for i = 0 to listcount-1
  if icons(i)<>"" then
    caption=captions(i)
    captions(i)="<img border='0' src='" & icons(i) & "'" & " alt='" & caption & "'>" & "<br>" & captions(i)
  end if
next  
end sub

sub GenerateHelpFile (filename)
dim url, urlimage
Response.write "<td align=center class=normalbold>"
url=generateurlpop(filename,readlang("langhelpme"))
urlimage=Generateimageurlpop(filename,readlang("langhelpme"), "iconhelp.gif")
Responsewrite urlimage &  "<br>" & url
Responsewrite "</td>"
end sub

Function GetrowColor (count)
dim r, rowcolor
r = count Mod 2
if r <> 0 then
     rowColor = "roweven"
else
      rowColor = "rowodd"
end if
getrowcolor=rowcolor      
end function


function CreateRadioListHor (fieldname, fieldvalue, listarray, listcount, captions)
dim i, selected
dim radiovalue, radiotext, caption
for i =0 to listcount-1
    radiovalue=listarray(i)
    caption=captions(i)
   if fieldvalue<>"" and radiovalue=fieldvalue then 
      selected=" checked"
   else
     selected=""
   end if      
   response.write "<td class='edit_toolbar' valign=top align=center>" 
   responsewrite "<input type=radio " & " name='" & fieldname & "'" & " value='" & radiovalue & "'" & selected & ">"
   response.write "<br>" & caption 
   response.write "</td>" & vbcrlf
next
end function

'***************************************************************************************
' Generates a row using an array 
'****************************************************************************************
Function WriteFormRowList1 (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldhelpmessage)
responsewrite "<td valign='top' class='NormalBold'>" & fieldcaption  & "&nbsp;"
responsewrite "<br>"
CreateSelectionList fieldname, fieldvalue, listarray, listcount, prompt
responsewrite "</td>"
end function


'***************************************************************************************
' Generates a row using an array of three columns
' caption, list, textbox
'****************************************************************************************
Function WriteFormRowListSelection1 (fieldcaption, fieldname, fieldvalue, fieldrequired, fieldsize, fieldvalid, listarray, listcount, prompt, fieldselect)
dim i
responsewrite  "<td valign=top>"
responsewrite (Htmlleftfont)
responsewrite (fieldcaption)
responsewrite "<br>"
CreateSelectionList fieldname, fieldvalue, listarray, listcount, prompt
responsewrite "<br>"
Responsewrite ("<input type='text' name='" & fieldselect & "'" & " size='" & fieldsize & "'" & " value='" & fieldvalue & "'>")
responsewrite (htmlcolumnend)
end function

Sub GeneratetableHeader (msg)
Responsewrite "<center><h2>" &  msg & "</h2></center>" & vbcrlf
end sub

sub GenerateReturnURL (filename, caption, icon)
dim url, urlimage
Response.write "<td align=center class=normalbold>"
url=generateurl(filename,caption)
urlimage=Generateimageurl(filename,caption, icon)
Responsewrite urlimage &  "<br>" & url
Responsewrite "</td>"
end sub

'********************************************************************************
' start of with system date and adjust for any time difference
'*********************************************************************************
Function GetCurrentdate
dim newdate, currentdate
currentdate=date()
afh_adjustdate currentdate, newdate
getcurrentdate=newdate
end function

'********************************************************************************
' start of with system date and adjust for any time difference
'*********************************************************************************
Function GetCurrentTime
dim newtime, currenttime
currenttime=time()
afh_adjusttime currenttime, newtime
getcurrenttime=newtime
end function

'*******************************************************************************
' adjust date based on time difference
'******************************************************************************
Sub Afh_adjustdate (olddate, newdate)
dim hh, timediff
newdate=olddate
timediff=readconfig("config_timedifference")
If timediff="" then 
    exit sub
end if    
' Support Time Difference     
hh=hour(olddate)
hh=clng(hh)+clng(timediff)
if hh>=24 then
    newdate=DateAdd("d",1,olddate)
elseif hh<0 then
    newdate=DateAdd("d",-1,olddate) 
else  
    newdate=olddate
end if 
' june 6
newdate=cdate(newdate)
end sub

'*****************************************************************
' take input time and adjust for time difference
'*****************************************************************
Sub Afh_AdjustTime (oldtime, newtime)
dim timediff
newtime=oldtime
timediff=readconfig("config_timedifference")
If timediff<>"" then
  if isnumeric(timediff) then
     newtime=DateAdd("h",timediff,oldtime) 
     newtime=formatdatetime(newtime, vblongtime)
  end if
end if   
'Debugwrite "oldtime=" & oldtime & " newtime=" & newtime
end sub


'*****************************************************************************
' adds  message  to errormsg global variable
'****************************************************************************
Sub writeError (msg)
errormessages(errorcount)=msg
errorcount=errorcount+1
end sub

Sub DisplayErrorMessages 
dim i, msg
if errorcount=0 then exit sub
Response.write "<table align=center border='1'>"
for i=0 to errorcount-1
  msg=errormessages(i) 
  response.write "<tr><td class='NormalError'>" & msg & "</td></tr>"
next  
response.write "</table>"
errorcount=0
end sub
%>
